Option Strict Off
Option Explicit On

Friend Class PSA_Access
    Inherits System.Windows.Forms.Form
    '/***********************************************************************/
    '/*                                                                     */
    '/*     IF-70@API_Test  for Visual Basic .net 2005                     */
    '/*       Interface   USB / RS-232C                                     */
    '/*                                                                     */
    '/***********************************************************************/

	Public DeviceId As Integer 'Device Handle
	Public IF_Sel As Short 'IF_select 0:close,1:USB,2:COM1
    Public res As Integer 'return Value
    Public flg As Integer 'return Value
    Public SYSAddr As String 'local Addr Name
    Public PcAddr As Integer 'PC Addr


    Private Sub Command1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command1.Click 'device OPEN/CLOSE

        If Command1.Text = "OPEN" Then 'device OPEN
            Select Case (Combo1.Text)
                Case "USB"
                    IF_Sel = IF_USB
				Case "COM"
					IF_Sel = IF_COM1
			End Select

            PcAddr = Val(Combo2.Text)
            SYSAddr = "ADRS " & Trim(Combo3.Text)
            DeviceId = PSA_DeviceOpen(PcAddr)

            If DeviceId > 0 Then
                res = PSA_Send(PcAddr, SYSAddr)
                res = PSA_Send(PcAddr, C_OUT_OFF)
                res = PSA_Send(PcAddr, C_DISP1)
                Command1.Text = "CLOSE"
                Command2.Enabled = True
                Command2.Text = "ON"
                Command3.Enabled = True
                Command4.Enabled = True
                Command5.Enabled = True
                'Command6.Enabled = True
                Command7.Enabled = True
                Text1.Text = ""
            Else
                Text1.Text = " Device Open ERR"
            End If
        Else 'device close
            Command2.Text = "ON"
            Command2.BackColor = System.Drawing.SystemColors.Control
            res = PSA_Send(PcAddr, C_OUT_OFF)
            res = PSA_Send(PcAddr, C_REMOTE_OFF)
            res = PSA_Send(PcAddr, C_ADDR & "1")
            res = PSA_Send(PcAddr, C_REMOTE_OFF)
            res = PSA_SetRemote(PcAddr, 0)
            res = PSA_DeviceClose(PcAddr)

            Command1.Text = "OPEN"
            Command2.Enabled = False
            Command3.Enabled = False
            Command4.Enabled = False
            Command5.Enabled = False
            Command6.Enabled = False
            Command7.Enabled = False
            Text1.Text = ""
            IF_Sel = 0
        End If
    End Sub

    Private Sub Command2_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command2.Click 'OUTPUT On/Off
        If Command2.Text = "ON" Then
            Command2.Text = "OFF"
            res = PSA_Send(PcAddr, C_OUT_ON)
            Command2.BackColor = System.Drawing.Color.Red
        Else
            Command2.Text = "ON"
            res = PSA_Send(PcAddr, C_OUT_OFF)
            Command2.BackColor = System.Drawing.SystemColors.Control
        End If
    End Sub

    Private Sub Command3_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command3.Click 'Preset 1 call
        res = PSA_Send(PcAddr, C_PRESET & "1")
    End Sub

    Private Sub Command4_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command4.Click 'Preset 2 call
        res = PSA_Send(PcAddr, C_PRESET & "2")
    End Sub

    Private Sub Command5_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command5.Click 'Preset 3 call
        res = PSA_Send(PcAddr, C_PRESET & "3")
    End Sub

    Private Sub Command6_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command6.Click 'Preset Off
        res = PSA_Send(PcAddr, C_PRESET & "1")
    End Sub

    Private Sub Command7_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command7.Click 'Request Monitoring Value
        Dim bbuf As String
        Dim meas_value As Object

        bbuf = Space(64)
        res = PSA_Send(PcAddr, C_READBACK)
        res = PSA_Recive(PcAddr, 64, bbuf)
        meas_value = Split(bbuf, ",")
        If UBound(meas_value) > 2 Then
            Text1.Text = Str(meas_value(2)) & "V" & vbCrLf & Str(meas_value(3)) & "A" & vbCrLf & Str(meas_value(2) * meas_value(3)) & "W" & vbCrLf & Str(meas_value(1)) & "  0:CV/1:CC/2:OFF"
        End If
        System.Windows.Forms.Application.DoEvents()
    End Sub

    Private Sub Combo1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo1.SelectedIndexChanged
        If Combo1.Text = "COM" Then
            Label4.Text = "COM PORT"
        Else
            Label4.Text = "PC ADDR"
        End If
    End Sub

    Private Sub PSA_Access_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load 'Form Load
        Dim index As Short

        Combo1.Items.Add(("USB"))
		Combo1.Items.Add(("COM"))
        For index = 1 To 30
            Combo2.Items.Add((Str(index)))
            Combo3.Items.Add((Str(index)))
        Next index
    End Sub

    Private Sub PSA_Access_FormClosing(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Dim Cancel As Boolean = eventArgs.Cancel
        Dim UnloadMode As System.Windows.Forms.CloseReason = eventArgs.CloseReason 'Form Close(x Button)
        If IF_Sel <> 0 Then
            res = PSA_Send(PcAddr, C_OUT_ON)
            res = PSA_Send(PcAddr, C_REMOTE_OFF)
            res = PSA_Send(PcAddr, C_ADDR & "1")
            res = PSA_Send(PcAddr, C_REMOTE_OFF)
            res = PSA_DeviceClose(PcAddr)
        End If
        eventArgs.Cancel = Cancel
    End Sub

    '/***********************************************************************/
    '/*     IF-60@Interface Select                                         */
    '/***********************************************************************/

    Private Function PSA_DeviceOpen(ByRef addr As Integer) As Integer

        Select Case (IF_Sel)
            Case IF_USB
                PSA_DeviceOpen = USB488_DeviceOpen(addr)

			Case IF_COM1
				SerialPort1.PortName = "COM" & Trim(Str(PcAddr))
				SerialPort1.Open()

				PSA_DeviceOpen = 1

		End Select
    End Function

    Private Function PSA_DeviceClose(ByRef addr As Integer) As Integer

        Select Case (IF_Sel)
            Case IF_USB
                PSA_DeviceClose = USB488_DeviceClose(addr)

			Case IF_COM1
				SerialPort1.Close()
				PSA_DeviceClose = 0

		End Select
    End Function

    Private Function PSA_SetRemote(ByRef addr As Integer, ByRef rMode As Integer) As Integer

        Select Case (IF_Sel)
            Case IF_USB
                PSA_SetRemote = USB488_SetRemote(addr, rMode)

            Case IF_COM1
                PSA_SetRemote = 0

        End Select
    End Function

    Private Function PSA_Send(ByRef addr As Integer, ByRef strBuf As String) As Integer

        Select Case (IF_Sel)
            Case IF_USB
                PSA_Send = USB488_Send(addr, strBuf)

			Case IF_COM1
				SerialPort1.DiscardInBuffer()
                SerialPort1.WriteLine(strBuf + vbLf)
				PSA_Send = Len(strBuf)
		End Select
    End Function

    Private Function PSA_Recive(ByRef addr As Integer, ByRef Count As Integer, ByRef strBuf As String) As Integer
        strBuf = Space(Count + 1)
        Select Case (IF_Sel)
            Case IF_USB
                PSA_Recive = USB488_Receive(addr, Count, strBuf)
                If PSA_Recive > 0 Then
                    strBuf = Strings.Left(strBuf, PSA_Recive)
                End If

            Case IF_COM1
                Sleep(200)
                strBuf = SerialPort1.ReadExisting
                PSA_Recive = Len(strBuf)
        End Select
    End Function

  
  
End Class